﻿' code is Copyright (c) 2006 Julian M Bucknall, www.boyet.com
Public Class BSTreeNode(Of K As IComparable(Of K), V)
    Inherits SimpleNode

    Private _key As K
    Public Property Key() As K
        Get
            Return _key
        End Get
        Set(ByVal Value As K)
            _key = Value
        End Set
    End Property

    Private _value As V
    Public Property Value() As V
        Get
            Return _value
        End Get
        Set(ByVal Value As V)
            _value = Value
        End Set
    End Property

    Public Sub New(ByVal key As K, ByVal value As V)
        _key = key
        _value = value
    End Sub

    Public Function Advance(ByVal key As K) As BSTreeNode(Of K, V)
        Dim compareResult As Integer = key.CompareTo(Me.Key)
        If compareResult = 0 Then Return Me
        If compareResult < 0 Then Return Left
        Return Right
    End Function

End Class
