' code is Copyright (c) 2006 Julian M Bucknall, www.boyet.com
Imports System.Drawing.Drawing2D


Public Class BsTreeNodePainter(Of K As IComparable(Of K), V)
    Inherits SimpleNodePainter

    Public Sub New(ByVal g As Graphics, ByVal unit As Single)
        MyBase.New(g, unit)
    End Sub

    Protected Overrides Sub DrawData(ByVal node As IBinaryNode, ByVal number As Integer, ByVal nodeRect As RectangleF)
        nodeRect.Offset(0.2F, 0.1F)
        Dim charNode As BSTreeNode(Of K, V) = DirectCast(node, BSTreeNode(Of K, V))
        If charNode IsNot Nothing Then
            _surface.DrawString(charNode.Key.ToString(), _font, _fontBrush, nodeRect)
        End If
    End Sub

End Class